#
# "@(#) $Id: LApplication.py,v 1.13 2004/07/26 16:46:23 duane Exp $"
#
# This work is released under the GNU GPL, version 2 or later.
#
from kdeemul import *
from LMainWindow import *
from LMusicPlayer import *
from LMusicBurner import *
from LMusicImporter import *
from LMusicRipper import *
from LMusicCDMounter import *
from Library import *
from LRadioLibrary import *
from LSettings import *
from LsongsPaths import *
from utils import *
from FileBasedPlayer import *
#import gc

_theApplication = None
#gc.set_debug(gc.DEBUG_STATS | gc.DEBUG_UNCOLLECTABLE)

class LApplication(KUniqueApplication):
	def __init__(self,version):
		global _theApplication
		_theApplication = self
		KUniqueApplication.__init__(self)
		self.initStuff()
		QObject.connect(self,SIGNAL("lastWindowClosed()"),self.saveStuff)
		try:
			QObject.connect(self,SIGNAL("aboutToQuit()"),self.saveStuff)
		except: pass
		#QObject.connect(self,SIGNAL("saveYourself()"),self.saveStuff)
		self.settings = LSettings.settings()
		self.window = LMainWindow(version)
		self.window.app = self
		p = eval(self.settings.get("Main Window Position",'[100,100,800,500]'))
		if len(p)!=4:
			p = [100,100,800,500]
		self.window.setGeometry(p[0],p[1],p[2],p[3])
		self.setMainWidget(self.window)
		self.window.show()
		self.buildSystemTray()
		self.saved = False

	def newInstance(self):
		args = KCmdLineArgs.parsedArgs()
		if args:
			if args.isSet("suspend"):
				LMusicPlayer.killCurrentPlayer()
		return 0
			
	def initStuff(self):
		progress = QProgressDialog("Initializing",None,2,None,"progress",True)
		progress.setCaption(i18n("Initializing Lsongs"))
		progress.setTotalSteps(2)
		progress.setLabelText(i18n("Initializing audio system"))
		progress.setMinimumDuration(0)
		time.sleep(1)
		progress.forceShow()
		progress.setProgress(0)
		x = LMusicPlayer.xine()
		progress.setLabelText(i18n("Scanning for CD writers"))
		progress.setProgress(1)
		progress.forceShow()
		x = CDR.getBurnerDevices()
		progress.setProgress(2)
		progress.forceShow()

	def saveStuff(self):
		if not self.saved:
			LMusicPlayer.killCurrentPlayer()
			print "saving library"
			lib = Library.mainLibrary()
			lib.writeBinaryFile()
			lib.writeXMLFile()
			LRadioLibrary.singleton().writeXMLFile()
			LSettings.singleton().writeXMLFile()
			print "killing threads"
			LMusicBurner.killCurrentBurner()
			LMusicRipper.killCurrentRipper()
			LMusicImporter.killCurrentImporter()
			LMusicCDMounter.killCurrentCDMounter()
			LMusicPlayer.killAll()
			self.saved = True

	def buildSystemTray(self):
		try:
			self.tray = KSystemTray(self.window)
			self.tray.setPixmap(QPixmap(art("lsongs_22.png")))
			menu = self.tray.contextMenu()
			self.window.playAction.plug(menu)
			self.window.pauseAction.plug(menu)
			self.window.nextSongAction.plug(menu)
			self.window.previousSongAction.plug(menu)
			QToolTip.add(self.tray,"Lsongs")
			self.tray.show()
			QObject.connect(LMusicPlayer.singleton(),PYSIGNAL("status"),self.updateSystrayTooltip)
		except: pass

	def updateSystrayTooltip(self,status):
		newText = "Lsongs"
		if status['Status']=='Playing':
			track = status['Track']
			newText = unikode(track.title)
			artist = unikode(track.artist)
			if artist!=None:
				newText = u"%s - %s" % (artist,newText)
		oldText = unikode(QToolTip.textFor(self.tray))
		if oldText!=newText:
			QToolTip.remove(self.tray)
			QToolTip.add(self.tray,QString(newText))
			
	def static_singleton():
		global _theApplication
		return _theApplication
	singleton = staticmethod(static_singleton)
